var logger = require('winston');
var http = require('http');
var channel;

var wifi_routers = [
  {
    title : "Satelite Link",
    status: "Unkown",
    url: "http://192.168.0.1/",
    device: "HT2000"
  },
  {
    title : "Main Router",
    status: "Unkown",
    url: "http://192.168.100.1/",
    device: "Wireless N 300M"
  },
  {
    title : "Repeater 1",
    status: "Unkown",
    url: "http://192.168.100.100/",
    device: "300M Wireless N Nano Router"
  }
]

module.exports.start = function(){
  logger.info("Starting wifi routers controller module");
  setInterval(function () {
    logger.info("Checking WIFI Routers...");
    checkURL(wifi_routers[0].url, 0);
    checkURL(wifi_routers[1].url, 1);
    checkURL(wifi_routers[2].url, 2);
  }, 60000);
}

module.exports.monitor = function(socket, channel_config){
  channel = channel_config;
  socket.on('wifi_routers_update', function (data) {
    socket.emit("wifi_routers", wifi_routers);
  });
}

module.exports.change_state = function(id, status){
  wifi_routers[id].status = status;
  channel.emit("wifi_routers", wifi_routers);
}

module.exports.check_status = function(id){
  checkURL(wifi_routers[id].url, id);
}

module.exports.send_status = function(){
  channel.emit("wifi_routers", wifi_routers);
}

var checkURL = function(url, n){
  http.get(url, function (res) {
    wifi_routers[n].status = "Active"
  }).on('error', function(e) {
    wifi_routers[n].status = "Inactive"
  });;
}
